<?php
	//Check the command line arguments
	if(sizeof($argv) < 2) { 
		echo  "Usage: php shared_memory.php <send|get|delete> <integer identifier> <value>\n";	
		exit;
	}	

	//Define shared memory segment properties.	
	$key = "987654";
	$permissions = 0666;	
	$size = 1024;
	
	//Create or open the shared memory segment.
	$segment = shm_attach($key, $size, $permissions);

	//Handle operations for the segment.
	switch($argv[1]) {
		case "send":
			shm_put_var($segment, $argv[2], $argv[3]);
			echo "Message sent to shared memory segment.\n";
			break;
		case "get":
			$data = shm_get_var($segment, $argv[2]);
			echo "Received data: {$data}\n";
			break;
		case "delete":
			shm_remove($segment);
			echo "Shared memory segment content deleted.\n";
			break;
		case "detach":
			shm_remove($segment);
			shm_detach($segment);
			echo "Shared memory segment has been detached and the content has been deleted\n";
			break;
	}
?>
